----------------------------------------------------------------------
-- Created by SmartDesign Wed Jun 06 22:32:24 2018
-- Version: v11.8 SP3 11.8.3.6
----------------------------------------------------------------------

----------------------------------------------------------------------
-- Libraries
----------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

library proasic3;
use proasic3.all;
----------------------------------------------------------------------
-- tb_top entity declaration
----------------------------------------------------------------------
entity tb_top is
    -- Port list
    port(
        -- Outputs
        Addr : out std_logic_vector(6 downto 0);
        DOUT : out std_logic_vector(7 downto 0);
        QA   : out std_logic_vector(3 downto 0);
        QB   : out std_logic_vector(3 downto 0);
        QC   : out std_logic_vector(3 downto 0);
        SEL  : out std_logic_vector(1 downto 0);
        nL   : out std_logic_vector(3 downto 0)
        );
end tb_top;
----------------------------------------------------------------------
-- tb_top architecture body
----------------------------------------------------------------------
architecture RTL of tb_top is
----------------------------------------------------------------------
-- Component declarations
----------------------------------------------------------------------
-- tb_clk
component tb_clk
    -- Port list
    port(
        -- Outputs
        HCLK  : out std_logic;
        HRSTn : out std_logic
        );
end component;
-- tb_ROM
component tb_ROM
    -- Port list
    port(
        -- Inputs
        ADDR : in  std_logic_vector(6 downto 0);
        CLK  : in  std_logic;
        -- Outputs
        DOUT : out std_logic_vector(7 downto 0)
        );
end component;
-- top
component top
    -- Port list
    port(
        -- Inputs
        C2   : in  std_logic_vector(3 downto 0);
        CLK  : in  std_logic;
        Im   : in  std_logic_vector(3 downto 0);
        OP   : in  std_logic_vector(3 downto 0);
        nRST : in  std_logic;
        -- Outputs
        Addr : out std_logic_vector(6 downto 0);
        QA   : out std_logic_vector(3 downto 0);
        QB   : out std_logic_vector(3 downto 0);
        QC   : out std_logic_vector(3 downto 0);
        SEL  : out std_logic_vector(1 downto 0);
        nL   : out std_logic_vector(3 downto 0)
        );
end component;
----------------------------------------------------------------------
-- Signal declarations
----------------------------------------------------------------------
signal Addr_net_0        : std_logic_vector(6 downto 0);
signal DOUT_net_0        : std_logic_vector(7 downto 0);
signal nL_net_0          : std_logic_vector(3 downto 0);
signal QA_net_0          : std_logic_vector(3 downto 0);
signal QB_net_0          : std_logic_vector(3 downto 0);
signal QC_net_0          : std_logic_vector(3 downto 0);
signal SEL_net_0         : std_logic_vector(1 downto 0);
signal tb_clk_0_HCLK     : std_logic;
signal tb_clk_0_HRSTn    : std_logic;
signal tb_ROM_0_DOUT3to0 : std_logic_vector(3 downto 0);
signal tb_ROM_0_DOUT7to4 : std_logic_vector(7 downto 4);
signal Addr_net_1        : std_logic_vector(6 downto 0);
signal DOUT_net_1        : std_logic_vector(7 downto 0);
signal nL_net_1          : std_logic_vector(3 downto 0);
signal SEL_net_1         : std_logic_vector(1 downto 0);
signal QC_net_1          : std_logic_vector(3 downto 0);
signal QA_net_1          : std_logic_vector(3 downto 0);
signal QB_net_1          : std_logic_vector(3 downto 0);
----------------------------------------------------------------------
-- TiedOff Signals
----------------------------------------------------------------------
signal C2_const_net_0    : std_logic_vector(3 downto 0);

begin
----------------------------------------------------------------------
-- Constant assignments
----------------------------------------------------------------------
 C2_const_net_0 <= B"0001";
----------------------------------------------------------------------
-- Top level output port assignments
----------------------------------------------------------------------
 Addr_net_1       <= Addr_net_0;
 Addr(6 downto 0) <= Addr_net_1;
 DOUT_net_1       <= DOUT_net_0;
 DOUT(7 downto 0) <= DOUT_net_1;
 nL_net_1         <= nL_net_0;
 nL(3 downto 0)   <= nL_net_1;
 SEL_net_1        <= SEL_net_0;
 SEL(1 downto 0)  <= SEL_net_1;
 QC_net_1         <= QC_net_0;
 QC(3 downto 0)   <= QC_net_1;
 QA_net_1         <= QA_net_0;
 QA(3 downto 0)   <= QA_net_1;
 QB_net_1         <= QB_net_0;
 QB(3 downto 0)   <= QB_net_1;
----------------------------------------------------------------------
-- Slices assignments
----------------------------------------------------------------------
 tb_ROM_0_DOUT3to0 <= DOUT_net_0(3 downto 0);
 tb_ROM_0_DOUT7to4 <= DOUT_net_0(7 downto 4);
----------------------------------------------------------------------
-- Component instances
----------------------------------------------------------------------
-- tb_clk_0
tb_clk_0 : tb_clk
    port map( 
        -- Outputs
        HCLK  => tb_clk_0_HCLK,
        HRSTn => tb_clk_0_HRSTn 
        );
-- tb_ROM_0
tb_ROM_0 : tb_ROM
    port map( 
        -- Inputs
        CLK  => tb_clk_0_HCLK,
        ADDR => Addr_net_0,
        -- Outputs
        DOUT => DOUT_net_0 
        );
-- top_0
top_0 : top
    port map( 
        -- Inputs
        CLK  => tb_clk_0_HCLK,
        nRST => tb_clk_0_HRSTn,
        C2   => C2_const_net_0,
        OP   => tb_ROM_0_DOUT7to4,
        Im   => tb_ROM_0_DOUT3to0,
        -- Outputs
        QC   => QC_net_0,
        Addr => Addr_net_0,
        nL   => nL_net_0,
        SEL  => SEL_net_0,
        QA   => QA_net_0,
        QB   => QB_net_0 
        );

end RTL;
