----------------------------------------------------------------------
-- Created by SmartDesign Wed Jun 06 22:31:46 2018
-- Version: v11.8 SP3 11.8.3.6
----------------------------------------------------------------------

----------------------------------------------------------------------
-- Libraries
----------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

library proasic3;
use proasic3.all;
----------------------------------------------------------------------
-- top entity declaration
----------------------------------------------------------------------
entity top is
    -- Port list
    port(
        -- Inputs
        C2   : in  std_logic_vector(3 downto 0);
        CLK  : in  std_logic;
        Im   : in  std_logic_vector(3 downto 0);
        OP   : in  std_logic_vector(3 downto 0);
        nRST : in  std_logic;
        -- Outputs
        Addr : out std_logic_vector(6 downto 0);
        QA   : out std_logic_vector(3 downto 0);
        QB   : out std_logic_vector(3 downto 0);
        QC   : out std_logic_vector(3 downto 0);
        SEL  : out std_logic_vector(1 downto 0);
        nL   : out std_logic_vector(3 downto 0)
        );
end top;
----------------------------------------------------------------------
-- top architecture body
----------------------------------------------------------------------
architecture RTL of top is
----------------------------------------------------------------------
-- Component declarations
----------------------------------------------------------------------
-- ALU
component ALU
    -- Port list
    port(
        -- Inputs
        A : in  std_logic_vector(3 downto 0);
        B : in  std_logic_vector(3 downto 0);
        -- Outputs
        C : out std_logic;
        Q : out std_logic_vector(3 downto 0)
        );
end component;
-- CFlg
component CFlg
    -- Port list
    port(
        -- Inputs
        C    : in  std_logic;
        CLK  : in  std_logic;
        nRST : in  std_logic;
        -- Outputs
        Q    : out std_logic
        );
end component;
-- Decorder
component Decorder
    -- Port list
    port(
        -- Inputs
        CF  : in  std_logic;
        OP  : in  std_logic_vector(3 downto 0);
        -- Outputs
        SEL : out std_logic_vector(1 downto 0);
        nL  : out std_logic_vector(3 downto 0)
        );
end component;
-- MUX
component MUX
    -- Port list
    port(
        -- Inputs
        C0  : in  std_logic_vector(3 downto 0);
        C1  : in  std_logic_vector(3 downto 0);
        C2  : in  std_logic_vector(3 downto 0);
        C3  : in  std_logic_vector(3 downto 0);
        sel : in  std_logic_vector(1 downto 0);
        -- Outputs
        Y   : out std_logic_vector(3 downto 0)
        );
end component;
-- PC
component PC
    -- Port list
    port(
        -- Inputs
        CLK  : in  std_logic;
        D    : in  std_logic_vector(3 downto 0);
        nL   : in  std_logic;
        nRST : in  std_logic;
        -- Outputs
        Addr : out std_logic_vector(6 downto 0)
        );
end component;
-- regA
component regA
    -- Port list
    port(
        -- Inputs
        A    : in  std_logic_vector(3 downto 0);
        CLK  : in  std_logic;
        nL   : in  std_logic;
        nRST : in  std_logic;
        -- Outputs
        Q    : out std_logic_vector(3 downto 0)
        );
end component;
-- regB
component regB
    -- Port list
    port(
        -- Inputs
        B    : in  std_logic_vector(3 downto 0);
        CLK  : in  std_logic;
        nL   : in  std_logic;
        nRST : in  std_logic;
        -- Outputs
        Q    : out std_logic_vector(3 downto 0)
        );
end component;
-- regC
component regC
    -- Port list
    port(
        -- Inputs
        C    : in  std_logic_vector(3 downto 0);
        CLK  : in  std_logic;
        nL   : in  std_logic;
        nRST : in  std_logic;
        -- Outputs
        Q    : out std_logic_vector(3 downto 0)
        );
end component;
----------------------------------------------------------------------
-- Signal declarations
----------------------------------------------------------------------
signal Addr_net_0        : std_logic_vector(6 downto 0);
signal ALU_0_C           : std_logic;
signal ALU_0_Q           : std_logic_vector(3 downto 0);
signal CFlg_0_Q          : std_logic;
signal Decorder_0_nL0to0 : std_logic_vector(0 to 0);
signal Decorder_0_nL1to1 : std_logic_vector(1 to 1);
signal Decorder_0_nL2to2 : std_logic_vector(2 to 2);
signal Decorder_0_nL3to3 : std_logic_vector(3 to 3);
signal MUX_0_Y           : std_logic_vector(3 downto 0);
signal nL_net_0          : std_logic_vector(3 downto 0);
signal QA_net_0          : std_logic_vector(3 downto 0);
signal QB_net_0          : std_logic_vector(3 downto 0);
signal QC_net_0          : std_logic_vector(3 downto 0);
signal SEL_net_0         : std_logic_vector(1 downto 0);
signal QC_net_1          : std_logic_vector(3 downto 0);
signal Addr_net_1        : std_logic_vector(6 downto 0);
signal nL_net_1          : std_logic_vector(3 downto 0);
signal SEL_net_1         : std_logic_vector(1 downto 0);
signal QA_net_1          : std_logic_vector(3 downto 0);
signal QB_net_1          : std_logic_vector(3 downto 0);
----------------------------------------------------------------------
-- TiedOff Signals
----------------------------------------------------------------------
signal C3_const_net_0    : std_logic_vector(3 downto 0);

begin
----------------------------------------------------------------------
-- Constant assignments
----------------------------------------------------------------------
 C3_const_net_0 <= B"0000";
----------------------------------------------------------------------
-- Top level output port assignments
----------------------------------------------------------------------
 QC_net_1         <= QC_net_0;
 QC(3 downto 0)   <= QC_net_1;
 Addr_net_1       <= Addr_net_0;
 Addr(6 downto 0) <= Addr_net_1;
 nL_net_1         <= nL_net_0;
 nL(3 downto 0)   <= nL_net_1;
 SEL_net_1        <= SEL_net_0;
 SEL(1 downto 0)  <= SEL_net_1;
 QA_net_1         <= QA_net_0;
 QA(3 downto 0)   <= QA_net_1;
 QB_net_1         <= QB_net_0;
 QB(3 downto 0)   <= QB_net_1;
----------------------------------------------------------------------
-- Slices assignments
----------------------------------------------------------------------
 Decorder_0_nL0to0(0) <= nL_net_0(0);
 Decorder_0_nL1to1(1) <= nL_net_0(1);
 Decorder_0_nL2to2(2) <= nL_net_0(2);
 Decorder_0_nL3to3(3) <= nL_net_0(3);
----------------------------------------------------------------------
-- Component instances
----------------------------------------------------------------------
-- ALU_0
ALU_0 : ALU
    port map( 
        -- Inputs
        A => MUX_0_Y,
        B => Im,
        -- Outputs
        C => ALU_0_C,
        Q => ALU_0_Q 
        );
-- CFlg_0
CFlg_0 : CFlg
    port map( 
        -- Inputs
        CLK  => CLK,
        nRST => nRST,
        C    => ALU_0_C,
        -- Outputs
        Q    => CFlg_0_Q 
        );
-- Decorder_0
Decorder_0 : Decorder
    port map( 
        -- Inputs
        CF  => CFlg_0_Q,
        OP  => OP,
        -- Outputs
        SEL => SEL_net_0,
        nL  => nL_net_0 
        );
-- MUX_0
MUX_0 : MUX
    port map( 
        -- Inputs
        C0  => QA_net_0,
        C1  => QB_net_0,
        C2  => C2,
        C3  => C3_const_net_0,
        sel => SEL_net_0,
        -- Outputs
        Y   => MUX_0_Y 
        );
-- PC_0
PC_0 : PC
    port map( 
        -- Inputs
        CLK  => CLK,
        nRST => nRST,
        nL   => Decorder_0_nL3to3(3),
        D    => ALU_0_Q,
        -- Outputs
        Addr => Addr_net_0 
        );
-- regA_0
regA_0 : regA
    port map( 
        -- Inputs
        CLK  => CLK,
        nRST => nRST,
        nL   => Decorder_0_nL0to0(0),
        A    => ALU_0_Q,
        -- Outputs
        Q    => QA_net_0 
        );
-- regB_0
regB_0 : regB
    port map( 
        -- Inputs
        CLK  => CLK,
        nRST => nRST,
        nL   => Decorder_0_nL1to1(1),
        B    => ALU_0_Q,
        -- Outputs
        Q    => QB_net_0 
        );
-- regC_0
regC_0 : regC
    port map( 
        -- Inputs
        CLK  => CLK,
        nRST => nRST,
        nL   => Decorder_0_nL2to2(2),
        C    => ALU_0_Q,
        -- Outputs
        Q    => QC_net_0 
        );

end RTL;
