--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: Decorder.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::ProASIC3> <Die::A3PN250> <Package::100 VQFP>
-- Author: <Name>
--
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Decorder is
    port (
        OP  : IN  std_logic_vector(3 downto 0); -- operation code
        CF  : IN  std_logic;
        SEL : OUT std_logic_vector(1 downto 0); -- selecter
        nL  : OUT std_logic_vector(3 downto 0)  -- nLoad
        --<other_ports>;
    );
end Decorder;

architecture RTL of Decorder is
   -- signal, component etc. declarations
begin
    process (OP, CF) begin
        case (OP) is
            -- for TD4 CPU decorder
            when "0000" => SEL <= "00"; nL <= "1110";   -- 1    ADD A,Im
            when "0001" => SEL <= "01"; nL <= "1110";   -- 2    MOV A,B
            when "0010" => SEL <= "10"; nL <= "1110";   -- 3    IN A
            when "0011" => SEL <= "11"; nL <= "1110";   -- 4    MOV A,Im
            when "0100" => SEL <= "00"; nL <= "1101";   -- 5    MOV B,A
            when "0101" => SEL <= "01"; nL <= "1101";   -- 6    ADD B,Im
            when "0110" => SEL <= "10"; nL <= "1101";   -- 7    IN B
            when "0111" => SEL <= "11"; nL <= "1101";   -- 8    MOV B,Im
            when "1001" => SEL <= "01"; nL <= "1011";   -- 9    OUT B
            when "1011" => SEL <= "11"; nL <= "1011";   -- 10   OUT Im
            --
            when "1110" => 
                if (CF = '0') then
                    SEL <= "00"; nL <= "0111";          -- 11   JNC(C=0)
                else
                    SEL <= "00"; nL <= "1111";          -- 12   JNC(C=1)
                end if;
            --
            when "1111" => SEL <= "11"; nL <= "0111";   -- 13   JMP
            --
            when others => SEL <= "00"; nL <= "0000";
        end case;
    end process;
   -- architecture body
end RTL;
