-- This software is distributed under the terms of the new BSD License.
-- Copyright (c) 2014 molelord
-- All rights reserved.

-- TD4の命令を定数として定義し、ほかのファイルから参照できるようにする。

library ieee;
use ieee.std_logic_1164.all;

package td4inst_pkg is

    constant MOV_A_IM : std_logic_vector(3 downto 0) := "0011";
    constant MOV_B_IM : std_logic_vector(3 downto 0) := "0111";
    constant MOV_A_B  : std_logic_vector(3 downto 0) := "0001";
    constant MOV_B_A  : std_logic_vector(3 downto 0) := "0100";
    constant ADD_A_IM : std_logic_vector(3 downto 0) := "0000";
    constant ADD_B_IM : std_logic_vector(3 downto 0) := "0101";
    constant IN_A     : std_logic_vector(3 downto 0) := "0010";
    constant IN_B     : std_logic_vector(3 downto 0) := "0110";
    constant OUT_IM   : std_logic_vector(3 downto 0) := "1011";
    constant OUT_B    : std_logic_vector(3 downto 0) := "1001";
    constant JMP_IM   : std_logic_vector(3 downto 0) := "1111";
    constant JNC_IM   : std_logic_vector(3 downto 0) := "1110";

    constant SEL_A     : std_logic_vector(1 downto 0) := "00";
    constant SEL_B     : std_logic_vector(1 downto 0) := "01";
    constant SEL_IPORT : std_logic_vector(1 downto 0) := "10";
    constant SEL_ZERO  : std_logic_vector(1 downto 0) := "11";

end; -- package

package body td4inst_pkg is
end; -- package body
