-- Version: v11.8 SP3 11.8.3.6

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity acc is

    port( DataA  : in    std_logic_vector(3 downto 0);
          Cin    : in    std_logic;
          Enable : in    std_logic;
          Aclr   : in    std_logic;
          Clock  : in    std_logic;
          Sum    : out   std_logic_vector(3 downto 0);
          Cout   : out   std_logic
        );

end acc;

architecture DEF_ARCH of acc is 

  component DFN1C1
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component MAJ3
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component INV
    port( A : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XOR3
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

    signal \Sum[0]\, \Sum[1]\, \Sum[2]\, \Sum[3]\, \SumInt[0]\, 
        \SumInt[1]\, \SumInt[2]\, \SumInt[3]\, MAJ3_1_Y, MAJ3_0_Y, 
        MAJ3_3_Y, MAJ3_2_Y, INV_1_Y, INV_0_Y, MX2_2_Y, MX2_0_Y, 
        MX2_1_Y, MX2_3_Y : std_logic;

begin 

    Sum(0) <= \Sum[0]\;
    Sum(1) <= \Sum[1]\;
    Sum(2) <= \Sum[2]\;
    Sum(3) <= \Sum[3]\;

    \DFN1C1_Sum[1]\ : DFN1C1
      port map(D => MX2_2_Y, CLK => Clock, CLR => INV_0_Y, Q => 
        \Sum[1]\);
    
    MAJ3_3 : MAJ3
      port map(A => MAJ3_0_Y, B => DataA(2), C => \Sum[2]\, Y => 
        MAJ3_3_Y);
    
    MX2_0 : MX2
      port map(A => \SumInt[0]\, B => \Sum[0]\, S => Enable, Y
         => MX2_0_Y);
    
    INV_0 : INV
      port map(A => Aclr, Y => INV_0_Y);
    
    \XOR3_SumInt[0]\ : XOR3
      port map(A => DataA(0), B => \Sum[0]\, C => INV_1_Y, Y => 
        \SumInt[0]\);
    
    \DFN1C1_Sum[2]\ : DFN1C1
      port map(D => MX2_1_Y, CLK => Clock, CLR => INV_0_Y, Q => 
        \Sum[2]\);
    
    MX2_3 : MX2
      port map(A => \SumInt[3]\, B => \Sum[3]\, S => Enable, Y
         => MX2_3_Y);
    
    \XOR3_SumInt[3]\ : XOR3
      port map(A => DataA(3), B => \Sum[3]\, C => MAJ3_3_Y, Y => 
        \SumInt[3]\);
    
    \DFN1C1_Sum[3]\ : DFN1C1
      port map(D => MX2_3_Y, CLK => Clock, CLR => INV_0_Y, Q => 
        \Sum[3]\);
    
    MAJ3_1 : MAJ3
      port map(A => INV_1_Y, B => DataA(0), C => \Sum[0]\, Y => 
        MAJ3_1_Y);
    
    INV_1 : INV
      port map(A => Cin, Y => INV_1_Y);
    
    \XOR3_SumInt[1]\ : XOR3
      port map(A => DataA(1), B => \Sum[1]\, C => MAJ3_1_Y, Y => 
        \SumInt[1]\);
    
    MAJ3_2 : MAJ3
      port map(A => MAJ3_3_Y, B => DataA(3), C => \Sum[3]\, Y => 
        MAJ3_2_Y);
    
    \XOR3_SumInt[2]\ : XOR3
      port map(A => DataA(2), B => \Sum[2]\, C => MAJ3_0_Y, Y => 
        \SumInt[2]\);
    
    MX2_2 : MX2
      port map(A => \SumInt[1]\, B => \Sum[1]\, S => Enable, Y
         => MX2_2_Y);
    
    INV_Cout : INV
      port map(A => MAJ3_2_Y, Y => Cout);
    
    \DFN1C1_Sum[0]\ : DFN1C1
      port map(D => MX2_0_Y, CLK => Clock, CLR => INV_0_Y, Q => 
        \Sum[0]\);
    
    MX2_1 : MX2
      port map(A => \SumInt[2]\, B => \Sum[2]\, S => Enable, Y
         => MX2_1_Y);
    
    MAJ3_0 : MAJ3
      port map(A => MAJ3_1_Y, B => DataA(1), C => \Sum[1]\, Y => 
        MAJ3_0_Y);
    

end DEF_ARCH; 

-- _Disclaimer: Please leave the following comments in the file, they are for internal purposes only._


-- _GEN_File_Contents_

-- Version:11.8.3.6
-- ACTGENU_CALL:1
-- BATCH:T
-- FAM:PA3LC
-- OUTFORMAT:VHDL
-- LPMTYPE:LPM_ADD_SUB
-- LPM_HINT:RIPACC
-- INSERT_PAD:NO
-- INSERT_IOREG:NO
-- GEN_BHV_VHDL_VAL:F
-- GEN_BHV_VERILOG_VAL:F
-- MGNTIMER:F
-- MGNCMPL:T
-- DESDIR:C:/Actelprj/test80_cpu/smartgen\acc
-- GEN_BEHV_MODULE:F
-- SMARTGEN_DIE:UM4X4M1N
-- SMARTGEN_PACKAGE:vq100
-- AGENIII_IS_SUBPROJECT_LIBERO:T
-- CI_POLARITY:0
-- CO_POLARITY:0
-- WIDTH:4
-- EN_POLARITY:0
-- CLR_POLARITY:0
-- CLK_EDGE:RISE
-- FF_TYPE:REGULAR
-- CLR_FANIN:AUTO
-- CLR_VAL:8
-- EN_FANIN:AUTO
-- EN_VAL:6
-- CLK_FANIN:MANUAL
-- CLK_VAL:1
-- DEBUG:0

-- _End_Comments_

