-- Version: v11.8 SP3 11.8.3.6

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity decoder is

    port( Data0  : in    std_logic;
          Data1  : in    std_logic;
          Enable : in    std_logic;
          Eq     : out   std_logic_vector(3 downto 0)
        );

end decoder;

architecture DEF_ARCH of decoder is 

  component NAND3B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NAND3C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NAND3A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;


begin 


    \NAND3B_Eq[1]\ : NAND3B
      port map(A => Data1, B => Enable, C => Data0, Y => Eq(1));
    
    \NAND3C_Eq[0]\ : NAND3C
      port map(A => Data1, B => Data0, C => Enable, Y => Eq(0));
    
    \NAND3A_Eq[3]\ : NAND3A
      port map(A => Enable, B => Data0, C => Data1, Y => Eq(3));
    
    \NAND3B_Eq[2]\ : NAND3B
      port map(A => Enable, B => Data0, C => Data1, Y => Eq(2));
    

end DEF_ARCH; 

-- _Disclaimer: Please leave the following comments in the file, they are for internal purposes only._


-- _GEN_File_Contents_

-- Version:11.8.3.6
-- ACTGENU_CALL:1
-- BATCH:T
-- FAM:PA3LC
-- OUTFORMAT:VHDL
-- LPMTYPE:LPM_DECODE
-- LPM_HINT:PndgenDecode
-- INSERT_PAD:NO
-- INSERT_IOREG:NO
-- GEN_BHV_VHDL_VAL:F
-- GEN_BHV_VERILOG_VAL:F
-- MGNTIMER:F
-- MGNCMPL:T
-- DESDIR:C:/Actelprj/test80_cpu/smartgen\decoder
-- GEN_BEHV_MODULE:F
-- SMARTGEN_DIE:UM4X4M1N
-- SMARTGEN_PACKAGE:vq100
-- AGENIII_IS_SUBPROJECT_LIBERO:T
-- DECODES:4
-- EN_POLARITY:0
-- EQ_POLARITY:0

-- _End_Comments_

