-- Version: v11.8 SP3 11.8.3.6

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity regB is

    port( QB_c      : out   std_logic_vector(3 downto 0);
          ALU_0_Q_0 : in    std_logic;
          N_10_i    : in    std_logic;
          N_12_i    : in    std_logic;
          N_14_i    : in    std_logic;
          m5        : in    std_logic;
          nRST_c    : in    std_logic;
          CLK_c     : in    std_logic
        );

end regB;

architecture DEF_ARCH of regB is 

  component DFN1E1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          E   : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

    signal \GND\, \VCC\ : std_logic;

begin 


    \tmp[1]\ : DFN1E1C0
      port map(D => N_14_i, CLK => CLK_c, CLR => nRST_c, E => m5, 
        Q => QB_c(1));
    
    \tmp[3]\ : DFN1E1C0
      port map(D => N_10_i, CLK => CLK_c, CLR => nRST_c, E => m5, 
        Q => QB_c(3));
    
    \tmp[2]\ : DFN1E1C0
      port map(D => N_12_i, CLK => CLK_c, CLR => nRST_c, E => m5, 
        Q => QB_c(2));
    
    \tmp[0]\ : DFN1E1C0
      port map(D => ALU_0_Q_0, CLK => CLK_c, CLR => nRST_c, E => 
        m5, Q => QB_c(0));
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    GND_i : GND
      port map(Y => \GND\);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity regC is

    port( QC_c      : out   std_logic_vector(3 downto 0);
          ALU_0_Q_0 : in    std_logic;
          N_10_i    : in    std_logic;
          N_12_i    : in    std_logic;
          N_14_i    : in    std_logic;
          m6        : in    std_logic;
          nRST_c    : in    std_logic;
          CLK_c     : in    std_logic
        );

end regC;

architecture DEF_ARCH of regC is 

  component DFN1E1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          E   : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

    signal \GND\, \VCC\ : std_logic;

begin 


    \tmp[1]\ : DFN1E1C0
      port map(D => N_14_i, CLK => CLK_c, CLR => nRST_c, E => m6, 
        Q => QC_c(1));
    
    \tmp[3]\ : DFN1E1C0
      port map(D => N_10_i, CLK => CLK_c, CLR => nRST_c, E => m6, 
        Q => QC_c(3));
    
    \tmp[2]\ : DFN1E1C0
      port map(D => N_12_i, CLK => CLK_c, CLR => nRST_c, E => m6, 
        Q => QC_c(2));
    
    \tmp[0]\ : DFN1E1C0
      port map(D => ALU_0_Q_0, CLK => CLK_c, CLR => nRST_c, E => 
        m6, Q => QC_c(0));
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    GND_i : GND
      port map(Y => \GND\);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity PC is

    port( Addr_c    : out   std_logic_vector(6 downto 0);
          ALU_0_Q_0 : in    std_logic;
          nRST_c    : in    std_logic;
          CLK_c     : in    std_logic;
          N_14_i    : in    std_logic;
          N_12_i    : in    std_logic;
          N_10_i    : in    std_logic;
          m9        : in    std_logic
        );

end PC;

architecture DEF_ARCH of PC is 

  component DFN1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component AX1C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR2B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XA1
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

  component NOR3C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

    signal tmp_n3, tmp_c2, N_9, \Addr_c[3]\, tmp_n6, tmp_14_0, 
        \Addr_c[6]\, tmp_n5, \Addr_c[5]\, tmp_c4, tmp_n4, 
        tmp_n4_tz, \Addr_c[4]\, tmp_n2, tmp_c1, N_7, tmp_n1, 
        \Addr_c[0]\, N_5, tmp_n0, \Addr_c[2]\, \Addr_c[1]\, \GND\, 
        \VCC\ : std_logic;

begin 

    Addr_c(6) <= \Addr_c[6]\;
    Addr_c(5) <= \Addr_c[5]\;
    Addr_c(4) <= \Addr_c[4]\;
    Addr_c(3) <= \Addr_c[3]\;
    Addr_c(2) <= \Addr_c[2]\;
    Addr_c(1) <= \Addr_c[1]\;
    Addr_c(0) <= \Addr_c[0]\;

    \tmp[2]\ : DFN1C0
      port map(D => tmp_n2, CLK => CLK_c, CLR => nRST_c, Q => 
        \Addr_c[2]\);
    
    \tmp_RNO_0[4]\ : AX1C
      port map(A => tmp_c2, B => \Addr_c[3]\, C => \Addr_c[4]\, Y
         => tmp_n4_tz);
    
    \tmp_RNO[3]\ : AX1C
      port map(A => m9, B => tmp_c2, C => N_9, Y => tmp_n3);
    
    \tmp_RNO_0[6]\ : NOR2B
      port map(A => \Addr_c[5]\, B => tmp_c4, Y => tmp_14_0);
    
    \tmp_RNO_0[1]\ : MX2
      port map(A => N_14_i, B => \Addr_c[1]\, S => m9, Y => N_5);
    
    \tmp_RNO[6]\ : XA1
      port map(A => tmp_14_0, B => \Addr_c[6]\, C => m9, Y => 
        tmp_n6);
    
    \tmp[6]\ : DFN1C0
      port map(D => tmp_n6, CLK => CLK_c, CLR => nRST_c, Q => 
        \Addr_c[6]\);
    
    \tmp_RNIU64J[2]\ : NOR2B
      port map(A => \Addr_c[2]\, B => tmp_c1, Y => tmp_c2);
    
    \tmp[3]\ : DFN1C0
      port map(D => tmp_n3, CLK => CLK_c, CLR => nRST_c, Q => 
        \Addr_c[3]\);
    
    \tmp[5]\ : DFN1C0
      port map(D => tmp_n5, CLK => CLK_c, CLR => nRST_c, Q => 
        \Addr_c[5]\);
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    \tmp_RNO[1]\ : AX1C
      port map(A => m9, B => \Addr_c[0]\, C => N_5, Y => tmp_n1);
    
    \tmp_RNO_0[2]\ : MX2
      port map(A => N_12_i, B => \Addr_c[2]\, S => m9, Y => N_7);
    
    \tmp[1]\ : DFN1C0
      port map(D => tmp_n1, CLK => CLK_c, CLR => nRST_c, Q => 
        \Addr_c[1]\);
    
    \tmp_RNIJ3OC[1]\ : NOR2B
      port map(A => \Addr_c[1]\, B => \Addr_c[0]\, Y => tmp_c1);
    
    \tmp_RNO_0[3]\ : MX2
      port map(A => N_10_i, B => \Addr_c[3]\, S => m9, Y => N_9);
    
    \tmp[0]\ : DFN1C0
      port map(D => tmp_n0, CLK => CLK_c, CLR => nRST_c, Q => 
        \Addr_c[0]\);
    
    GND_i : GND
      port map(Y => \GND\);
    
    \tmp_RNO[2]\ : AX1C
      port map(A => m9, B => tmp_c1, C => N_7, Y => tmp_n2);
    
    \tmp[4]\ : DFN1C0
      port map(D => tmp_n4, CLK => CLK_c, CLR => nRST_c, Q => 
        \Addr_c[4]\);
    
    \tmp_RNO[5]\ : XA1
      port map(A => \Addr_c[5]\, B => tmp_c4, C => m9, Y => 
        tmp_n5);
    
    \tmp_RNINGSV[4]\ : NOR3C
      port map(A => tmp_c2, B => \Addr_c[3]\, C => \Addr_c[4]\, Y
         => tmp_c4);
    
    \tmp_RNO[4]\ : NOR2B
      port map(A => m9, B => tmp_n4_tz, Y => tmp_n4);
    
    \tmp_RNO[0]\ : MX2B
      port map(A => ALU_0_Q_0, B => \Addr_c[0]\, S => m9, Y => 
        tmp_n0);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity CFlg is

    port( i6_mux   : in    std_logic;
          nRST_c   : in    std_logic;
          CLK_c    : in    std_logic;
          CFlg_0_Q : out   std_logic
        );

end CFlg;

architecture DEF_ARCH of CFlg is 

  component DFN1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

    signal \GND\, \VCC\ : std_logic;

begin 


    tmp : DFN1C0
      port map(D => i6_mux, CLK => CLK_c, CLR => nRST_c, Q => 
        CFlg_0_Q);
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    GND_i : GND
      port map(Y => \GND\);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity MUX is

    port( C2_c      : in    std_logic_vector(3 downto 0);
          QA_c      : in    std_logic_vector(3 downto 0);
          MUX_0_Y   : out   std_logic_vector(3 downto 0);
          QB_c      : in    std_logic_vector(3 downto 0);
          sel_i_2_0 : in    std_logic;
          SEL_1_i_0 : in    std_logic;
          OP_c_0    : in    std_logic
        );

end MUX;

architecture DEF_ARCH of MUX is 

  component NOR2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

    signal N_20, N_28, N_23, N_22, N_21, N_31, N_30, N_29, \GND\, 
        \VCC\ : std_logic;

begin 


    \Y_2[3]\ : NOR2A
      port map(A => QB_c(3), B => OP_c_0, Y => N_23);
    
    \Y_3[0]\ : MX2
      port map(A => N_28, B => N_20, S => SEL_1_i_0, Y => 
        MUX_0_Y(0));
    
    \Y_1[3]\ : MX2
      port map(A => QA_c(3), B => C2_c(3), S => sel_i_2_0, Y => 
        N_31);
    
    \Y_2[0]\ : NOR2A
      port map(A => QB_c(0), B => OP_c_0, Y => N_20);
    
    \Y_3[3]\ : MX2
      port map(A => N_31, B => N_23, S => SEL_1_i_0, Y => 
        MUX_0_Y(3));
    
    \Y_1[2]\ : MX2
      port map(A => QA_c(2), B => C2_c(2), S => sel_i_2_0, Y => 
        N_30);
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    \Y_3[1]\ : MX2
      port map(A => N_29, B => N_21, S => SEL_1_i_0, Y => 
        MUX_0_Y(1));
    
    \Y_2[1]\ : NOR2A
      port map(A => QB_c(1), B => OP_c_0, Y => N_21);
    
    GND_i : GND
      port map(Y => \GND\);
    
    \Y_1[1]\ : MX2
      port map(A => QA_c(1), B => C2_c(1), S => sel_i_2_0, Y => 
        N_29);
    
    \Y_3[2]\ : MX2
      port map(A => N_30, B => N_22, S => SEL_1_i_0, Y => 
        MUX_0_Y(2));
    
    \Y_2[2]\ : NOR2A
      port map(A => QB_c(2), B => OP_c_0, Y => N_22);
    
    \Y_1[0]\ : MX2
      port map(A => QA_c(0), B => C2_c(0), S => sel_i_2_0, Y => 
        N_28);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity ALU is

    port( ALU_0_Q_0 : out   std_logic;
          Im_c      : in    std_logic_vector(3 downto 0);
          MUX_0_Y   : in    std_logic_vector(3 downto 0);
          i6_mux    : out   std_logic;
          N_12_i    : out   std_logic;
          N_14_i    : out   std_logic;
          N_10_i    : out   std_logic
        );

end ALU;

architecture DEF_ARCH of ALU is 

  component AO18
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AO13
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XOR2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XOR3
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR2B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component XNOR3
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MIN3
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

    signal i4_mux, N_2_i, i2_mux, \GND\, \VCC\ : std_logic;

begin 


    un3_tmp_m7 : AO18
      port map(A => Im_c(2), B => i2_mux, C => MUX_0_Y(2), Y => 
        i4_mux);
    
    un3_tmp_m17 : AO13
      port map(A => Im_c(3), B => MUX_0_Y(3), C => i4_mux, Y => 
        i6_mux);
    
    un3_tmp_m14 : XOR2
      port map(A => Im_c(0), B => MUX_0_Y(0), Y => ALU_0_Q_0);
    
    un3_tmp_m13 : XOR3
      port map(A => MUX_0_Y(1), B => Im_c(1), C => N_2_i, Y => 
        N_14_i);
    
    un3_tmp_m1 : NOR2B
      port map(A => Im_c(0), B => MUX_0_Y(0), Y => N_2_i);
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    un3_tmp_m9 : XNOR3
      port map(A => MUX_0_Y(3), B => Im_c(3), C => i4_mux, Y => 
        N_10_i);
    
    un3_tmp_m4 : MIN3
      port map(A => MUX_0_Y(1), B => N_2_i, C => Im_c(1), Y => 
        i2_mux);
    
    un3_tmp_m11 : XNOR3
      port map(A => MUX_0_Y(2), B => Im_c(2), C => i2_mux, Y => 
        N_12_i);
    
    GND_i : GND
      port map(Y => \GND\);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity regA is

    port( QA_c      : out   std_logic_vector(3 downto 0);
          ALU_0_Q_0 : in    std_logic;
          N_10_i    : in    std_logic;
          N_12_i    : in    std_logic;
          N_14_i    : in    std_logic;
          m4        : in    std_logic;
          nRST_c    : in    std_logic;
          CLK_c     : in    std_logic
        );

end regA;

architecture DEF_ARCH of regA is 

  component DFN1E1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          E   : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

    signal \GND\, \VCC\ : std_logic;

begin 


    \tmp[1]\ : DFN1E1C0
      port map(D => N_14_i, CLK => CLK_c, CLR => nRST_c, E => m4, 
        Q => QA_c(1));
    
    \tmp[3]\ : DFN1E1C0
      port map(D => N_10_i, CLK => CLK_c, CLR => nRST_c, E => m4, 
        Q => QA_c(3));
    
    \tmp[2]\ : DFN1E1C0
      port map(D => N_12_i, CLK => CLK_c, CLR => nRST_c, E => m4, 
        Q => QA_c(2));
    
    \tmp[0]\ : DFN1E1C0
      port map(D => ALU_0_Q_0, CLK => CLK_c, CLR => nRST_c, E => 
        m4, Q => QA_c(0));
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    GND_i : GND
      port map(Y => \GND\);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity Decorder is

    port( OP_c      : in    std_logic_vector(3 downto 0);
          SEL_1_i_0 : out   std_logic;
          sel_i_2_0 : out   std_logic;
          CFlg_0_Q  : in    std_logic;
          m9        : out   std_logic;
          m5        : out   std_logic;
          N_6_i     : out   std_logic;
          m4        : out   std_logic;
          N_5_i     : out   std_logic;
          m6        : out   std_logic;
          N_7_i     : out   std_logic
        );

end Decorder;

architecture DEF_ARCH of Decorder is 

  component NOR3C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component INV
    port( A : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component AOI1B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

  component NOR2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OA1A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OR2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

    signal \m6\, \m4\, \m5\, \SEL_1_i_a3_0[0]\, N_9, N_8, N_4, 
        \GND\, \VCC\ : std_logic;

begin 

    m5 <= \m5\;
    m4 <= \m4\;
    m6 <= \m6\;

    \nL_3_0__m7\ : NOR3C
      port map(A => OP_c(2), B => OP_c(1), C => CFlg_0_Q, Y => 
        N_8);
    
    \nL_3_0__N_5_i\ : INV
      port map(A => \m4\, Y => N_5_i);
    
    \nL_3_0__m4\ : MX2A
      port map(A => OP_c(2), B => N_4, S => OP_c(3), Y => \m4\);
    
    \nL_3_0__N_6_i\ : INV
      port map(A => \m5\, Y => N_6_i);
    
    \nL_3_0__m8\ : MX2B
      port map(A => N_8, B => OP_c(2), S => OP_c(0), Y => N_9);
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    \nL_3_0__SEL_1_i[0]\ : AOI1B
      port map(A => \SEL_1_i_a3_0[0]\, B => OP_c(2), C => OP_c(0), 
        Y => SEL_1_i_0);
    
    \nL_3_0__N_7_i\ : INV
      port map(A => \m6\, Y => N_7_i);
    
    \nL_3_0__m5\ : MX2
      port map(A => OP_c(2), B => N_4, S => OP_c(3), Y => \m5\);
    
    \nL_3_0__m3\ : MX2C
      port map(A => OP_c(0), B => OP_c(1), S => OP_c(2), Y => N_4);
    
    GND_i : GND
      port map(Y => \GND\);
    
    \nL_3_0__SEL_1_i_a3_0[0]\ : NOR2A
      port map(A => OP_c(3), B => OP_c(1), Y => \SEL_1_i_a3_0[0]\);
    
    \nL_3_0__m6\ : AOI1B
      port map(A => OP_c(1), B => OP_c(2), C => OP_c(3), Y => 
        \m6\);
    
    \nL_3_0__SEL_1_i[1]\ : OA1A
      port map(A => OP_c(3), B => OP_c(0), C => OP_c(1), Y => 
        sel_i_2_0);
    
    \nL_3_0__m9\ : OR2A
      port map(A => OP_c(3), B => N_9, Y => m9);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library proasic3;
use proasic3.all;

entity top is

    port( C2   : in    std_logic_vector(3 downto 0);
          CLK  : in    std_logic;
          Im   : in    std_logic_vector(3 downto 0);
          OP   : in    std_logic_vector(3 downto 0);
          nRST : in    std_logic;
          Addr : out   std_logic_vector(6 downto 0);
          QA   : out   std_logic_vector(3 downto 0);
          QB   : out   std_logic_vector(3 downto 0);
          QC   : out   std_logic_vector(3 downto 0);
          SEL  : out   std_logic_vector(1 downto 0);
          nL   : out   std_logic_vector(3 downto 0)
        );

end top;

architecture DEF_ARCH of top is 

  component OUTBUF
    port( D   : in    std_logic := 'U';
          PAD : out   std_logic
        );
  end component;

  component regB
    port( QB_c      : out   std_logic_vector(3 downto 0);
          ALU_0_Q_0 : in    std_logic := 'U';
          N_10_i    : in    std_logic := 'U';
          N_12_i    : in    std_logic := 'U';
          N_14_i    : in    std_logic := 'U';
          m5        : in    std_logic := 'U';
          nRST_c    : in    std_logic := 'U';
          CLK_c     : in    std_logic := 'U'
        );
  end component;

  component INBUF
    port( PAD : in    std_logic := 'U';
          Y   : out   std_logic
        );
  end component;

  component regC
    port( QC_c      : out   std_logic_vector(3 downto 0);
          ALU_0_Q_0 : in    std_logic := 'U';
          N_10_i    : in    std_logic := 'U';
          N_12_i    : in    std_logic := 'U';
          N_14_i    : in    std_logic := 'U';
          m6        : in    std_logic := 'U';
          nRST_c    : in    std_logic := 'U';
          CLK_c     : in    std_logic := 'U'
        );
  end component;

  component PC
    port( Addr_c    : out   std_logic_vector(6 downto 0);
          ALU_0_Q_0 : in    std_logic := 'U';
          nRST_c    : in    std_logic := 'U';
          CLK_c     : in    std_logic := 'U';
          N_14_i    : in    std_logic := 'U';
          N_12_i    : in    std_logic := 'U';
          N_10_i    : in    std_logic := 'U';
          m9        : in    std_logic := 'U'
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component CFlg
    port( i6_mux   : in    std_logic := 'U';
          nRST_c   : in    std_logic := 'U';
          CLK_c    : in    std_logic := 'U';
          CFlg_0_Q : out   std_logic
        );
  end component;

  component MUX
    port( C2_c      : in    std_logic_vector(3 downto 0) := (others => 'U');
          QA_c      : in    std_logic_vector(3 downto 0) := (others => 'U');
          MUX_0_Y   : out   std_logic_vector(3 downto 0);
          QB_c      : in    std_logic_vector(3 downto 0) := (others => 'U');
          sel_i_2_0 : in    std_logic := 'U';
          SEL_1_i_0 : in    std_logic := 'U';
          OP_c_0    : in    std_logic := 'U'
        );
  end component;

  component ALU
    port( ALU_0_Q_0 : out   std_logic;
          Im_c      : in    std_logic_vector(3 downto 0) := (others => 'U');
          MUX_0_Y   : in    std_logic_vector(3 downto 0) := (others => 'U');
          i6_mux    : out   std_logic;
          N_12_i    : out   std_logic;
          N_14_i    : out   std_logic;
          N_10_i    : out   std_logic
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

  component regA
    port( QA_c      : out   std_logic_vector(3 downto 0);
          ALU_0_Q_0 : in    std_logic := 'U';
          N_10_i    : in    std_logic := 'U';
          N_12_i    : in    std_logic := 'U';
          N_14_i    : in    std_logic := 'U';
          m4        : in    std_logic := 'U';
          nRST_c    : in    std_logic := 'U';
          CLK_c     : in    std_logic := 'U'
        );
  end component;

  component Decorder
    port( OP_c      : in    std_logic_vector(3 downto 0) := (others => 'U');
          SEL_1_i_0 : out   std_logic;
          sel_i_2_0 : out   std_logic;
          CFlg_0_Q  : in    std_logic := 'U';
          m9        : out   std_logic;
          m5        : out   std_logic;
          N_6_i     : out   std_logic;
          m4        : out   std_logic;
          N_5_i     : out   std_logic;
          m6        : out   std_logic;
          N_7_i     : out   std_logic
        );
  end component;

  component CLKBUF
    port( PAD : in    std_logic := 'U';
          Y   : out   std_logic
        );
  end component;

    signal \MUX_0_Y[1]\, \MUX_0_Y[2]\, \MUX_0_Y[3]\, CFlg_0_Q, 
        \GND\, \VCC\, \ALU_0.un3_tmp.i6_mux\, m4, m5, m6, m9, 
        \SEL_1_i[0]\, \MUX_0.sel_i_2[1]\, \C2_c[0]\, \C2_c[1]\, 
        \C2_c[2]\, \C2_c[3]\, CLK_c, \Im_c[0]\, \Im_c[1]\, 
        \Im_c[2]\, \Im_c[3]\, \OP_c[0]\, \OP_c[1]\, \OP_c[2]\, 
        \OP_c[3]\, nRST_c, \Addr_c[0]\, \Addr_c[1]\, \Addr_c[2]\, 
        \Addr_c[3]\, \Addr_c[4]\, \Addr_c[5]\, \Addr_c[6]\, 
        \QA_c[0]\, \QA_c[1]\, \QA_c[2]\, \QA_c[3]\, \QB_c[0]\, 
        \QB_c[1]\, \QB_c[2]\, \QB_c[3]\, \QC_c[0]\, \QC_c[1]\, 
        \QC_c[2]\, \QC_c[3]\, \ALU_0_Q[0]\, \MUX_0_Y[0]\, 
        \ALU_0.un3_tmp.N_10_i\, \ALU_0.un3_tmp.N_12_i\, 
        \ALU_0.un3_tmp.N_14_i\, \Decorder_0.nL_3_0_.N_7_i\, 
        \Decorder_0.nL_3_0_.N_6_i\, \Decorder_0.nL_3_0_.N_5_i\
         : std_logic;

    for all : regB
	Use entity work.regB(DEF_ARCH);
    for all : regC
	Use entity work.regC(DEF_ARCH);
    for all : PC
	Use entity work.PC(DEF_ARCH);
    for all : CFlg
	Use entity work.CFlg(DEF_ARCH);
    for all : MUX
	Use entity work.MUX(DEF_ARCH);
    for all : ALU
	Use entity work.ALU(DEF_ARCH);
    for all : regA
	Use entity work.regA(DEF_ARCH);
    for all : Decorder
	Use entity work.Decorder(DEF_ARCH);
begin 


    \QB_pad[0]\ : OUTBUF
      port map(D => \QB_c[0]\, PAD => QB(0));
    
    \QA_pad[1]\ : OUTBUF
      port map(D => \QA_c[1]\, PAD => QA(1));
    
    regB_0 : regB
      port map(QB_c(3) => \QB_c[3]\, QB_c(2) => \QB_c[2]\, 
        QB_c(1) => \QB_c[1]\, QB_c(0) => \QB_c[0]\, ALU_0_Q_0 => 
        \ALU_0_Q[0]\, N_10_i => \ALU_0.un3_tmp.N_10_i\, N_12_i
         => \ALU_0.un3_tmp.N_12_i\, N_14_i => 
        \ALU_0.un3_tmp.N_14_i\, m5 => m5, nRST_c => nRST_c, CLK_c
         => CLK_c);
    
    \Im_pad[0]\ : INBUF
      port map(PAD => Im(0), Y => \Im_c[0]\);
    
    \QB_pad[3]\ : OUTBUF
      port map(D => \QB_c[3]\, PAD => QB(3));
    
    \nL_pad[0]\ : OUTBUF
      port map(D => \Decorder_0.nL_3_0_.N_5_i\, PAD => nL(0));
    
    \nL_pad[2]\ : OUTBUF
      port map(D => \Decorder_0.nL_3_0_.N_7_i\, PAD => nL(2));
    
    regC_0 : regC
      port map(QC_c(3) => \QC_c[3]\, QC_c(2) => \QC_c[2]\, 
        QC_c(1) => \QC_c[1]\, QC_c(0) => \QC_c[0]\, ALU_0_Q_0 => 
        \ALU_0_Q[0]\, N_10_i => \ALU_0.un3_tmp.N_10_i\, N_12_i
         => \ALU_0.un3_tmp.N_12_i\, N_14_i => 
        \ALU_0.un3_tmp.N_14_i\, m6 => m6, nRST_c => nRST_c, CLK_c
         => CLK_c);
    
    \SEL_pad[0]\ : OUTBUF
      port map(D => \SEL_1_i[0]\, PAD => SEL(0));
    
    \QA_pad[3]\ : OUTBUF
      port map(D => \QA_c[3]\, PAD => QA(3));
    
    \Addr_pad[5]\ : OUTBUF
      port map(D => \Addr_c[5]\, PAD => Addr(5));
    
    PC_0 : PC
      port map(Addr_c(6) => \Addr_c[6]\, Addr_c(5) => \Addr_c[5]\, 
        Addr_c(4) => \Addr_c[4]\, Addr_c(3) => \Addr_c[3]\, 
        Addr_c(2) => \Addr_c[2]\, Addr_c(1) => \Addr_c[1]\, 
        Addr_c(0) => \Addr_c[0]\, ALU_0_Q_0 => \ALU_0_Q[0]\, 
        nRST_c => nRST_c, CLK_c => CLK_c, N_14_i => 
        \ALU_0.un3_tmp.N_14_i\, N_12_i => \ALU_0.un3_tmp.N_12_i\, 
        N_10_i => \ALU_0.un3_tmp.N_10_i\, m9 => m9);
    
    VCC_i : VCC
      port map(Y => \VCC\);
    
    \SEL_pad[1]\ : OUTBUF
      port map(D => \MUX_0.sel_i_2[1]\, PAD => SEL(1));
    
    \Addr_pad[2]\ : OUTBUF
      port map(D => \Addr_c[2]\, PAD => Addr(2));
    
    \QC_pad[0]\ : OUTBUF
      port map(D => \QC_c[0]\, PAD => QC(0));
    
    \Im_pad[2]\ : INBUF
      port map(PAD => Im(2), Y => \Im_c[2]\);
    
    CFlg_0 : CFlg
      port map(i6_mux => \ALU_0.un3_tmp.i6_mux\, nRST_c => nRST_c, 
        CLK_c => CLK_c, CFlg_0_Q => CFlg_0_Q);
    
    \OP_pad[2]\ : INBUF
      port map(PAD => OP(2), Y => \OP_c[2]\);
    
    MUX_0 : MUX
      port map(C2_c(3) => \C2_c[3]\, C2_c(2) => \C2_c[2]\, 
        C2_c(1) => \C2_c[1]\, C2_c(0) => \C2_c[0]\, QA_c(3) => 
        \QA_c[3]\, QA_c(2) => \QA_c[2]\, QA_c(1) => \QA_c[1]\, 
        QA_c(0) => \QA_c[0]\, MUX_0_Y(3) => \MUX_0_Y[3]\, 
        MUX_0_Y(2) => \MUX_0_Y[2]\, MUX_0_Y(1) => \MUX_0_Y[1]\, 
        MUX_0_Y(0) => \MUX_0_Y[0]\, QB_c(3) => \QB_c[3]\, QB_c(2)
         => \QB_c[2]\, QB_c(1) => \QB_c[1]\, QB_c(0) => \QB_c[0]\, 
        sel_i_2_0 => \MUX_0.sel_i_2[1]\, SEL_1_i_0 => 
        \SEL_1_i[0]\, OP_c_0 => \OP_c[1]\);
    
    \Addr_pad[1]\ : OUTBUF
      port map(D => \Addr_c[1]\, PAD => Addr(1));
    
    \QB_pad[2]\ : OUTBUF
      port map(D => \QB_c[2]\, PAD => QB(2));
    
    \C2_pad[0]\ : INBUF
      port map(PAD => C2(0), Y => \C2_c[0]\);
    
    \QC_pad[1]\ : OUTBUF
      port map(D => \QC_c[1]\, PAD => QC(1));
    
    \QC_pad[2]\ : OUTBUF
      port map(D => \QC_c[2]\, PAD => QC(2));
    
    \Addr_pad[3]\ : OUTBUF
      port map(D => \Addr_c[3]\, PAD => Addr(3));
    
    \QB_pad[1]\ : OUTBUF
      port map(D => \QB_c[1]\, PAD => QB(1));
    
    \Addr_pad[0]\ : OUTBUF
      port map(D => \Addr_c[0]\, PAD => Addr(0));
    
    \Im_pad[3]\ : INBUF
      port map(PAD => Im(3), Y => \Im_c[3]\);
    
    ALU_0 : ALU
      port map(ALU_0_Q_0 => \ALU_0_Q[0]\, Im_c(3) => \Im_c[3]\, 
        Im_c(2) => \Im_c[2]\, Im_c(1) => \Im_c[1]\, Im_c(0) => 
        \Im_c[0]\, MUX_0_Y(3) => \MUX_0_Y[3]\, MUX_0_Y(2) => 
        \MUX_0_Y[2]\, MUX_0_Y(1) => \MUX_0_Y[1]\, MUX_0_Y(0) => 
        \MUX_0_Y[0]\, i6_mux => \ALU_0.un3_tmp.i6_mux\, N_12_i
         => \ALU_0.un3_tmp.N_12_i\, N_14_i => 
        \ALU_0.un3_tmp.N_14_i\, N_10_i => \ALU_0.un3_tmp.N_10_i\);
    
    GND_i : GND
      port map(Y => \GND\);
    
    \C2_pad[3]\ : INBUF
      port map(PAD => C2(3), Y => \C2_c[3]\);
    
    \QA_pad[0]\ : OUTBUF
      port map(D => \QA_c[0]\, PAD => QA(0));
    
    \Addr_pad[4]\ : OUTBUF
      port map(D => \Addr_c[4]\, PAD => Addr(4));
    
    \nL_pad[3]\ : OUTBUF
      port map(D => m9, PAD => nL(3));
    
    \Im_pad[1]\ : INBUF
      port map(PAD => Im(1), Y => \Im_c[1]\);
    
    \C2_pad[1]\ : INBUF
      port map(PAD => C2(1), Y => \C2_c[1]\);
    
    \C2_pad[2]\ : INBUF
      port map(PAD => C2(2), Y => \C2_c[2]\);
    
    \OP_pad[3]\ : INBUF
      port map(PAD => OP(3), Y => \OP_c[3]\);
    
    nRST_pad : INBUF
      port map(PAD => nRST, Y => nRST_c);
    
    \Addr_pad[6]\ : OUTBUF
      port map(D => \Addr_c[6]\, PAD => Addr(6));
    
    \QA_pad[2]\ : OUTBUF
      port map(D => \QA_c[2]\, PAD => QA(2));
    
    \OP_pad[0]\ : INBUF
      port map(PAD => OP(0), Y => \OP_c[0]\);
    
    regA_0 : regA
      port map(QA_c(3) => \QA_c[3]\, QA_c(2) => \QA_c[2]\, 
        QA_c(1) => \QA_c[1]\, QA_c(0) => \QA_c[0]\, ALU_0_Q_0 => 
        \ALU_0_Q[0]\, N_10_i => \ALU_0.un3_tmp.N_10_i\, N_12_i
         => \ALU_0.un3_tmp.N_12_i\, N_14_i => 
        \ALU_0.un3_tmp.N_14_i\, m4 => m4, nRST_c => nRST_c, CLK_c
         => CLK_c);
    
    \QC_pad[3]\ : OUTBUF
      port map(D => \QC_c[3]\, PAD => QC(3));
    
    \nL_pad[1]\ : OUTBUF
      port map(D => \Decorder_0.nL_3_0_.N_6_i\, PAD => nL(1));
    
    \OP_pad[1]\ : INBUF
      port map(PAD => OP(1), Y => \OP_c[1]\);
    
    Decorder_0 : Decorder
      port map(OP_c(3) => \OP_c[3]\, OP_c(2) => \OP_c[2]\, 
        OP_c(1) => \OP_c[1]\, OP_c(0) => \OP_c[0]\, SEL_1_i_0 => 
        \SEL_1_i[0]\, sel_i_2_0 => \MUX_0.sel_i_2[1]\, CFlg_0_Q
         => CFlg_0_Q, m9 => m9, m5 => m5, N_6_i => 
        \Decorder_0.nL_3_0_.N_6_i\, m4 => m4, N_5_i => 
        \Decorder_0.nL_3_0_.N_5_i\, m6 => m6, N_7_i => 
        \Decorder_0.nL_3_0_.N_7_i\);
    
    CLK_pad : CLKBUF
      port map(PAD => CLK, Y => CLK_c);
    

end DEF_ARCH; 
